/*
 *  Brno University of Technology
 *
 *  Copyright (C) 2009-2010 by Brno University of Technology and the contributors
 *
 *  Complete list of developers available at our web site:
 *
 *       http://spl.utko.feec.vutbr.cz
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/.
 */
package cz.vutbr.feec.utko.opencv.operators;


import java.io.File;
import java.util.List;

import static com.googlecode.javacv.cpp.opencv_core.*;
import static com.googlecode.javacv.cpp.opencv_highgui.*;

import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.UserError;
import com.rapidminer.operator.ports.OutputPort;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeFile;

import cz.vutbr.feec.utko.opencv.io.OpenCVColorImage;
import cz.vutbr.feec.utko.opencv.io.OpenCVIOObject;

/**
 * The Class OpenCVToColorImage.
 */
public class ReadImage extends Operator {

	private static final String PARAM_FILENAME = "filename";
	private OutputPort outOpenCv = getOutputPorts().createPort("color image");

	public ReadImage(OperatorDescription description) {
		super(description);
		getTransformer().addGenerationRule(outOpenCv, OpenCVColorImage.class);

	}

	@Override
	public void doWork() throws OperatorException {
		File f = getParameterAsFile(PARAM_FILENAME);
		if (!f.exists()) {
			throw new UserError(this, 136, "File " + f.getPath()
					+ " does not exist." +System.getProperty("jna.library.path"));
		}
		OpenCVIOObject openCV = loadOpenCvImage(f.getPath());
		outOpenCv.deliver(openCV);
	}

	private OpenCVIOObject loadOpenCvImage(String path) {
		final int IS_COLOR = 1;
		IplImage image = cvLoadImage(path, IS_COLOR);
		return new OpenCVIOObject(image);
	}

	@Override
	public List<ParameterType> getParameterTypes() {
		List<ParameterType> p = super.getParameterTypes();
		p.add(new ParameterTypeFile(PARAM_FILENAME, "Input file name", "jpg",
				false));
		return p;
	}
}
